"""Tests for logging tag feature."""

import os
import re

import pytest

from ska_sdp_wflow_selfcal.pipeline.main import run_pipeline


def check_dp3_logfile(mock_settings, expected_logging_tag):
    """
    Checks that the DP3 logs contain the command, the default DP3 arguments
    from the config file, and the log message.
    """
    for i in range(4):
        dp3_logfile = (
            f"{mock_settings.work_dir}/logs/"
            f"DP3.{expected_logging_tag}.image_1.{i}.log"
        )
        assert os.path.isfile(dp3_logfile)
        with open(dp3_logfile, "r", encoding="utf-8") as dp3_log:
            command = dp3_log.readline()
            assert re.match(
                "^Running: .*/mock-DP3 .* checkparset=1 numthreads=4 ", command
            )

            message = dp3_log.readline()
            assert message == f"{mock_settings.dp3_log_line}\n"


def check_wsclean_logfile(mock_settings, expected_logging_tag):
    """Checks that the WSClean log contains the command and the log message."""
    wsclean_logfile = f"image_1/wsclean.{expected_logging_tag}.log"
    assert os.path.isfile(wsclean_logfile)
    with open(wsclean_logfile, "r", encoding="utf-8") as wsclean_log:
        command = wsclean_log.readline()
        assert re.match("^Running: .*/mock-wsclean ", command)

        lines = wsclean_log.readlines()
        assert len(lines) > 0
        for line in lines:
            assert line == f"{mock_settings.wsclean_log_line}\n"


@pytest.mark.parametrize("logging_tag", {None, "TAGtestingTAG"})
def test_logging(logging_tag, mock_settings, mocker):
    """Tests logging with and without an explicit tag."""

    expected_logging_tag = logging_tag or str(os.getpid())

    # Use a patch for the functions get_imaging_n_iterations
    # and concatenate_ms, since they need extra inputs that are not
    # available in the current testing environment.
    mocker.patch(
        "ska_sdp_wflow_selfcal.pipeline.operations.get_imaging_n_iterations"
    )
    mocker.patch("ska_sdp_wflow_selfcal.pipeline.operations.concatenate_ms")

    # Use a smaller minimum_time and a larger data_fraction so that DP3 will
    # use multithreading.
    with open(mock_settings.config_file, "r", encoding="utf-8") as file:
        filedata = file.read()
    filedata = re.sub(r"data_fraction: \d.\d", "data_fraction: 1.0", filedata)
    filedata = re.sub(r"minimum_time: \d+.\d", "minimum_time: 1.0", filedata)
    with open(mock_settings.config_file, "w", encoding="utf-8") as file:
        file.write(filedata)

    # Since filter_skymodel is disabled in the test configuration, create dummy
    # WSClean output files. The pipeline should rename those files to the files
    # otherwise generated by filter_skymodel.
    image_1_dir = f"{mock_settings.work_dir}/image_1"
    os.mkdir(image_1_dir)
    with open(
        f"{image_1_dir}/lofar-sources.txt", "w", encoding="utf-8"
    ) as file:
        file.write("Dummy sources.txt file.")
    with open(
        f"{image_1_dir}/lofar-sources-pb.txt", "w", encoding="utf-8"
    ) as file:
        file.write("Dummy sources-pb.txt file.")

    mock_settings.logging_tag = logging_tag
    # image_1 runs both DP3 and WSClean
    mock_settings.resume_from_operation = "image_1"
    mock_settings.run_single_operation = "True"

    run_pipeline(mock_settings)

    main_logfile = (
        f"{mock_settings.work_dir}/logs/"
        f"wflow-selfcal.{expected_logging_tag}.log"
    )

    # For the main log file, check that image_1 started and is done.
    assert os.path.isfile(main_logfile)
    with open(main_logfile, "r", encoding="utf-8") as main_log:
        main_log_contents = main_log.read()
        assert "run_pipeline:: Start image_1" in main_log_contents
        assert "run_pipeline:: Done image_1" in main_log_contents

    check_dp3_logfile(mock_settings, expected_logging_tag)
    check_wsclean_logfile(mock_settings, expected_logging_tag)

    # Check that the pipeline renamed the skymodel files.
    # TODO(AST-1397): Move these checks to the image() test in test_steps.py.
    assert not os.path.isfile(f"{image_1_dir}/lofar-sources.txt")
    assert not os.path.isfile(f"{image_1_dir}/lofar-sources-pb.txt")
    with open(f"{image_1_dir}/lofar.true_sky.txt", encoding="utf-8") as file:
        assert file.readline() == "Dummy sources.txt file."
    with open(
        f"{image_1_dir}/lofar.apparent_sky.txt", encoding="utf-8"
    ) as file:
        assert file.readline() == "Dummy sources-pb.txt file."
